# Redeem Underlying

The redeem underlying function converts aTokens into a specified quantity of the underlying asset, and returns them to the user. The amount of aTokens redeemed is equal to the quantity of underlying tokens received, divided by the current [Exchange Rate](https://docs.agilefi.org/atokens/exchange-rate). The amount redeemed must be less than the user's [Account Liquidity](https://github.com/agilefinance/agile-docs/tree/294e07fcebce7997c93709b5b9f8bbdb7e8271af/atokens/comptroller/get-account-liquidity.md) and the market's available liquidity.

**SErc20 / SEther**

```
function redeemUnderlying(uint redeemAmount) returns (uint)
```

* `msg.sender`: The account to which redeemed funds shall be transferred.
* `redeemAmount`: The amount of underlying to be redeemed.
* `RETURN`: 0 on success, otherwise an [Error code](https://docs.agilefi.org/atokens/error-codes)

**Solidity**

```
SEther aToken = SEther(0x3FDB...);
require(aToken.redeemUnderlying(50) == 0, "something went wrong");
```

**Web3 1.0**

```javascript
const aToken = SErc20.at(0x3FDA...);
aToken.methods.redeemUnderlying(10).send({from: ...});
```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.agilefi.org/atokens/redeem-underlying.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
